'use strict';

var GraphQL = require('graphql');
function getValidGraphQLTag(path) {
  var tag = path.get('tag');
  if (!tag.isIdentifier({
    name: 'graphql'
  })) {
    return null;
  }
  var quasis = path.node.quasi.quasis;
  if (quasis.length !== 1) {
    throw new Error('BabelPluginRelay: Substitutions are not allowed in graphql fragments. ' + 'Included fragments should be referenced as `...MyModule_propName`.');
  }
  var text = quasis[0].value.raw;
  var ast = GraphQL.parse(text);
  if (ast.definitions.length === 0) {
    throw new Error('BabelPluginRelay: Unexpected empty graphql tag.');
  }
  return ast;
}
module.exports = getValidGraphQLTag;